import pyglet
from gamelib import data, baselib

window = pyglet.window.Window(width=640, height=480)
block_batch = pyglet.graphics.Batch()
debug_batch = pyglet.graphics.Batch()
label_batch = pyglet.graphics.Batch()
game_info_batch = pyglet.graphics.Batch()
game_start_batch = pyglet.graphics.Batch()

game_time = 0
over_time = 300
answer_time = 0
right_time = 0
#now_commit = 0
game_match = 0
game_used_time = 0
game_non_start = 1
go_to_game_over = 0

nine_b = baselib.nine_blocks()
q_b = baselib.query_block(nine_b)

commit_f = data.load("commit.png")
commit_png = pyglet.image.load("commit.png", file=commit_f)

reset_f = data.load("reset.png")
reset_png = pyglet.image.load("reset.png", file=reset_f)

block_sprites = []

block_sprites.append( pyglet.sprite.Sprite(commit_png, x = 300, y = 375, batch = block_batch) )
block_sprites.append( pyglet.sprite.Sprite(reset_png, x = 230, y = 375, batch = block_batch) )

for i in xrange(9):
    nine_b.blocks[i].batch = label_batch
    nine_b.set_blocks_unchoice()

qb = baselib.make_a_question()
qb.set_values(nine_b)
qb.make_question_blocks()

question_label = pyglet.text.Label(qb.sum_question , font_size=14, x=20, y=400, batch=game_info_batch) 

game_over = pyglet.text.Label('' , color=(255,0,0,200), font_size=48, x=250, y=400, batch=game_info_batch)
game_time_label = pyglet.text.Label('Time: 00:00' , font_size=14, x=400, y=400, batch=game_info_batch)
game_match_label = pyglet.text.Label('Match: 0', font_size=14, x=400, y=380, batch=game_info_batch)
game_used_time_label = pyglet.text.Label('Used: 00:00', font_size=14, x=400, y=360, batch=game_info_batch)
mkedu_title = pyglet.text.Label('MkEdu', font_size=100, x=100, y=250, batch=game_start_batch)
sub_title = pyglet.text.Label('Caught the Number, Please.', font_size=24, x=100, y=180, batch=game_start_batch)

amsg = pyglet.text.Label('', font_size=14, x=20, y=430, batch=game_info_batch)              

@window.event
def on_draw():
    window.clear()
    block_batch.draw()
    label_batch.draw()
    debug_batch.draw()
    game_info_batch.draw()
    if game_non_start or go_to_game_over: game_start_batch.draw()
 
@window.event
def on_mouse_press(x, y, button, modifiers):
    global amsg, game_match, game_non_start, go_to_game_over
    
    game_non_start = 0
    nine_b.after_comment()
    
    if game_over.text == "Game Over":
        go_to_game_over = 1
        mkedu_title.text = "Milk2Cow.com"
        mkedu_title.font_size = 48
        sub_title.text = "this game make by miker"
    
    v, i = q_b.query_m_hit(baselib.x_y_point(x,y))
    if v:
        nine_b.hit_block(v)

    if ( x > 300 ) and ( x < 350) and ( y > 375 ) and ( y < 400 ):
        nine_b.find_answer()

        if nine_b.answer_values == qb.question_blocks:        
            amsg.text = nine_b.answer_msg + '  (right + match)'
            game_match += 1
            game_match_label.text = 'Match: %s' %str(game_match)
        elif nine_b.answer_sum == qb.qbv_sum:
            amsg.text = nine_b.answer_msg + ' (right, but not match)'
        else:
            amsg.text = nine_b.answer_msg + ' (your answer isn\'t right)'
        nine_b.commit_happen()
    
    if ( x > 230) and ( x < 280) and ( y > 375) and ( y < 400):
        nine_b.set_blocks_values()
        qb.set_values(nine_b)
        qb.make_question_blocks( int( game_match / 5 ) + 1)
        nine_b.set_blocks_unchoice()
        question_label.text = qb.sum_question 
        amsg.text = ""

def time_label_maker(time):
    sec = int( time % 60 )
    if sec < 10:
        sec_t = '0%s' %sec
    else:
        sec_t = str(sec)
    mins = int ( time / 60 )
    return '%s:%s' %(mins, sec_t)
                       
def update(dt):
    global game_time, right_time, game_used_time
    game_time += dt
    #if not nine_b.now_commit: game_used_time += dt
    game_used_time_label.text = 'Used: %s' %time_label_maker( game_time )
    #sec = int( ( over_time - game_time ) % 60 )
    game_time_label.text = 'Time: %s' %time_label_maker( over_time - game_time)
    if game_time > 300:
        game_over.text = 'Game Over'

# Call update 60 times a second
pyglet.clock.schedule_interval(update, 1/60.)                
    
def main():    
    pyglet.app.run()

if __name__ == '__main__':
    main()
